<?php
/*
Plugin Name: MyPolls.2
Version: 2.1.0alpha
Description: Plugin pour faire des sondages sur sa gallerie / Plugin to carry out surveys on its gallery 
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=181
Author: grum@piwigo.org
Author URI: http://photos.grum.dnsaliascom/
*/

/*
--------------------------------------------------------------------------------
  Author     : Grum
    email    : grum@piwigo.com
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
--------------------------------------------------------------------------------

:: HISTORY
:: HISTORY
  2.0.0-beta  - 04/11/07  +refonte complète du plugin
  2.0.1-beta  - 10/11/07  +conservation & récupération des sondages de la version 1.x
                          -correction de messages d'erreurs js
                          -couleur du graphique d'un sondage correspond à la couleur affectée
                          -bloque l'activation d'un sondage si une traduction n'est faite qu'en partie
                          -procédure d'export (fichier SQL) automatique lors de la désinstallation
                          -usage du plugin GRUM_PLUGIN_CORE
  2.0.2       - 02/01/08  - correction template (ajax) pour être compatible avec IE7.0
                          - remplacement des "&" dans les URL par des "&amp;" pour être aux normes
  2.0.3       - 06/01/08  - correction insertions avec MySQL 5  
  2.0.4       - 06/01/08  - correction insertions&maj
                          - correction pb sur affichage de mypolls_action_ok
  2.0.5       - 25/05/08  - adaption du plugin suite à modification de la gestion
                            de google translator (cf. grum_plugin_classes v1.2.0)
  2.0.6       - 01/06/08  - correction pour compatibilité avec le plugin manager
                            http://forum.phpwebgallery.net/viewtopic.php?pid=89458#p89458
  2.0.7       - 01/06/08  - correction du bug 'lang'
                            http://forum.phpwebgallery.net/viewtopic.php?pid=89560#p89560
  2.1.0       - 06/11/08  - release for piwigo 2.0
                          + PHP5 classe
                          + install process can import database file (.sql) if present

:: TO DO

--------------------------------------------------------------------------------

:: NFO
  MyPolls_root : common classe for admin and public classes
  MyPolls_AIM  : classe to manage plugin integration into plugin menu
  MyPolls_AIP  : classe to manage plugin admin pages
  MyPolls_PIP  : classe to manage plugin public pages

--------------------------------------------------------------------------------
*/

// pour faciliter le debug :o)
// ini_set('error_reporting', E_ALL);
// ini_set('display_errors', true);

if(!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');


define('MYPOLLS_DIR' , basename(dirname(__FILE__)));
define('MYPOLLS_PATH' , PHPWG_PLUGINS_PATH . MYPOLLS_DIR . '/');

define('MYPOLLS_VERSION' , '2.1.0alpha'); // => ne pas oublier la version dans l'entête !!

global $prefixeTable;


if(defined('IN_ADMIN'))
{
  //MyPolls admin interface loaded and active only if in admin page
  include_once("mypolls_aim.class.inc.php");
  $obj=new MyPolls_AIM($prefixeTable, __FILE__);
  $obj->init_events();
}
else
{
  //MyPolls public interface loaded and active only if in public page
  include_once("mypolls_pip.class.inc.php");
  $obj=new MyPolls_PIP($prefixeTable, __FILE__);
}

set_plugin_data($plugin['id'], $obj);

?>
