<?php
/* -----------------------------------------------------------------------------
  Plugin     : MyPolls.2
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  --------------------------------------------------------------------------- */

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

define('MYPOLLS_DIR' , basename(dirname(__FILE__)));
define('MYPOLLS_PATH' , PHPWG_PLUGINS_PATH . MYPOLLS_DIR . '/');

//ini_set('error_reporting', E_ALL);
//ini_set('display_errors', true);

global $gpc_installed, $lang; //needed for plugin manager compatibility

/* -----------------------------------------------------------------------------
MyPolls-2 needs the Grum Plugin Classe
----------------------------------------------------------------------------- */
$gpc_installed=false;
if(file_exists(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/common_plugin.class.inc.php'))
{
  @include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/main.inc.php');
  // need GPC release greater or equal than 2.0.1
  if(checkGPCRelease(2,0,1))
  {
    @include_once('mypolls_install.class.inc.php');
    $gpc_installed=true;
  }
}

function gpcMsgError(&$errors)
{
  array_push($errors, sprintf(l10n('mypolls_gpc2_not_installed'), "2.0.1"));
}
// -----------------------------------------------------------------------------




load_language('plugin.lang', MYPOLLS_PATH);


function plugin_install($plugin_id, $plugin_version, &$errors) 
{
  global $prefixeTable, $gpc_installed;

  if($gpc_installed)
  {
    $obj = new MyPolls_Install($prefixeTable, __FILE__);
    $result=$obj->install();
    if(!$result)
    {
      array_push($errors, "error");
    }
  }
  else
  {
    gpcMsgError($errors);
  }
}

function plugin_activate($plugin_id, $plugin_version, &$errors)
{
  global $prefixeTable, $gpc_installed;

  if($gpc_installed)
  {
    $obj = new MyPolls_Install($prefixeTable, __FILE__);
    $result=$obj->activate();
    if($result===false or $result!='')
    {
      if(is_string($result))
      {
        array_push($errors, $result);
      }
      else
      {
        array_push($errors, "");
      }
    }
  }
  else
  {
    gpcMsgError($errors);
  }
}

function plugin_deactivate($plugin_id)
{
/*  global $prefixeTable;
  $obj = new install_mypolls($prefixeTable, __FILE__);
  $obj->deactivate(); */
}

function plugin_uninstall($plugin_id)
{
  global $prefixeTable, $gpc_installed;

  if($gpc_installed)
  {
    $obj = new MyPolls_Install($prefixeTable, __FILE__);
    $obj->uninstall();
  }
  else
  {
    gpcMsgError($errors);
  }
}


?>
